
/+ dub.sdl:
	name "dsp_output"
	dependency "dplug:core" version="*"
+/
module dsp_output;
/* ------------------------------------------------------------
author: "Oren Kurtz"
copyright: "Punk Labs LLC 2022"
license: "GPLv3-or-later"
name: "OneTrick SIMIAN"
version: "1.00"
Code generated with Faust 2.50.6 (https://faust.grame.fr)
Compilation options: -a arch.fastmath.d.template -lang dlang -cn DSP_Output -pn processOutput -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/************************************************************************
 IMPORTANT NOTE : this file contains two clearly delimited sections :
 the ARCHITECTURE section (in two parts) and the USER section. Each section
 is governed by its own copyright and license. Please check individually
 each section for license and copyright information.
 *************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2019 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 
 ************************************************************************
 ************************************************************************/

import std.math;
import std.stdio;
import std.conv;
import std.algorithm;
import std.format;
import core.stdc.stdlib;

/******************************************************************************
 *******************************************************************************
 
 VECTOR INTRINSICS
 
 *******************************************************************************
 *******************************************************************************/


/********************END ARCHITECTURE SECTION (part 1/2)****************/

/**************************BEGIN USER SECTION **************************/

/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱   
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱  
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━ 

	Copyright (c) 2022 Punk Labs LLC

	This section is part of OneTrick

	OneTrick is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	OneTrick is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

import onetrick.client;
alias pow = FastMath.pow;
alias sqrt = FastMath.sqrt;

import std.math;
import std.algorithm : min, max;
import dplug.core.nogc: mallocNew, mallocSlice, destroyFree, assumeNothrowNoGC;
alias FAUSTCLASS = DSP_Output;
static float DSP_Output_faustpower2_f(float value) nothrow @nogc {
	return value * value;
}

class DSP_Output : dsp
{
nothrow:
@nogc:
	
 private:
	
	int fSampleRate;
	float fConst1;
	float fConst4;
	float fConst5;
	float fConst7;
	float fConst8;
	int IOTA0;
	float[1024] fVec0;
	FAUSTFLOAT fHslider0;
	float[2] fRec9;
	float[2] fRec10;
	float[1024] fVec1;
	float[2] fRec11;
	float[2] fRec12;
	float[1024] fVec2;
	float[2] fRec13;
	float[2] fRec14;
	float[2048] fVec3;
	float[2] fRec15;
	float[2] fRec16;
	float[128] fVec4;
	float[2] fRec7;
	float[64] fVec5;
	float[2] fRec5;
	float[12] fVec6;
	float[2] fRec3;
	float[3] fRec2;
	float fConst9;
	FAUSTFLOAT fHslider1;
	float fConst10;
	float[3] fRec19;
	float fConst11;
	float[2] fRec18;
	int[2] iVec7;
	int iConst12;
	int[2] iRec20;
	float fConst13;
	float[2] fRec17;
	FAUSTFLOAT fCheckbox0;
	float[2] fVec8;
	FAUSTFLOAT fHslider2;
	float[2] fRec21;
	float fConst14;
	float fConst15;
	float[2] fRec1;
	float fConst16;
	float[2] fRec0;
	FAUSTFLOAT fHslider3;
	float[2] fRec22;
	FAUSTFLOAT fHslider4;
	float[2] fRec23;
	
 public:
	
	void metadata(Meta* m) nothrow @nogc { 
		m.declare("analyzers.lib/amp_follower_ar:author", "Jonatan Liljedahl, revised by Romain Michon");
		m.declare("analyzers.lib/name", "Faust Analyzer Library");
		m.declare("analyzers.lib/version", "0.2");
		m.declare("author", "Oren Kurtz");
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/version", "0.8");
		m.declare("compile_options", "-a arch.fastmath.d.template -lang dlang -cn DSP_Output -pn processOutput -es 1 -mcd 16 -single -ftz 0");
		m.declare("compressors.lib/compression_gain_mono:author", "Julius O. Smith III");
		m.declare("compressors.lib/compression_gain_mono:copyright", "Copyright (C) 2014-2020 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("compressors.lib/compression_gain_mono:license", "MIT-style STK-4.3 license");
		m.declare("compressors.lib/compressor_stereo:author", "Julius O. Smith III");
		m.declare("compressors.lib/compressor_stereo:copyright", "Copyright (C) 2014-2020 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("compressors.lib/compressor_stereo:license", "MIT-style STK-4.3 license");
		m.declare("compressors.lib/name", "Faust Compressor Effect Library");
		m.declare("compressors.lib/version", "0.4");
		m.declare("copyright", "Punk Labs LLC 2022");
		m.declare("delays.lib/name", "Faust Delay Library");
		m.declare("delays.lib/version", "0.1");
		m.declare("filename", "Main.dsp");
		m.declare("filters.lib/allpass_comb:author", "Julius O. Smith III");
		m.declare("filters.lib/allpass_comb:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/allpass_comb:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/fb_comb:author", "Julius O. Smith III");
		m.declare("filters.lib/fb_comb:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fb_comb:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/fir:author", "Julius O. Smith III");
		m.declare("filters.lib/fir:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fir:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:author", "Julius O. Smith III");
		m.declare("filters.lib/iir:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/rev1:author", "Julius O. Smith III");
		m.declare("filters.lib/rev1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/rev1:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/rev2:author", "Julius O. Smith III");
		m.declare("filters.lib/rev2:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/rev2:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2:author", "Julius O. Smith III");
		m.declare("filters.lib/tf2:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/tf2s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf2s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2s:license", "MIT-style STK-4.3 license");
		m.declare("filters.lib/version", "0.3");
		m.declare("interpolators.lib/interpolate_linear:author", "Stéphane Letz");
		m.declare("interpolators.lib/interpolate_linear:licence", "MIT");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "0.3");
		m.declare("license", "GPLv3-or-later");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.5");
		m.declare("misceffects.lib/name", "Misc Effects Library");
		m.declare("misceffects.lib/version", "2.0");
		m.declare("name", "OneTrick SIMIAN");
		m.declare("options", "[midi:on]");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "0.2");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/onePoleSwitching:author", "Jonatan Liljedahl, revised by Dario Sanfilippo");
		m.declare("signals.lib/onePoleSwitching:licence", "STK-4.3");
		m.declare("signals.lib/version", "0.3");
		m.declare("version", "1.00");
	}

	int getNumInputs() nothrow @nogc {
		return 3;
	}
	int getNumOutputs() nothrow @nogc {
		return 2;
	}
	
	static void classInit(int sample_rate) nothrow @nogc {
	}
	
	void instanceConstants(int sample_rate) nothrow @nogc {
		fSampleRate = sample_rate;
		float fConst0 = fmin(1.92e+05, fmax(1.0f, cast(float)(fSampleRate)));
		fConst1 = exp(0.0f - 1e+05 / fConst0);
		float fConst2 = tan(942.4778f / fConst0);
		float fConst3 = DSP_Output_faustpower2_f(fConst2);
		fConst4 = 1.0f / fConst3;
		fConst5 = 2.0f * (1.0f - fConst4);
		float fConst6 = 1.0f / fConst2;
		fConst7 = (fConst6 + -1.4142135f) / fConst2 + 1.0f;
		fConst8 = 1.0f / ((fConst6 + 1.4142135f) / fConst2 + 1.0f);
		fConst9 = 0.0f - 2.0f / fConst3;
		fConst10 = exp(0.0f - 1e+04 / fConst0);
		fConst11 = 1.0f - fConst10;
		iConst12 = cast(int)(0.1f * fConst0);
		fConst13 = exp(0.0f - 5e+01 / fConst0);
		fConst14 = exp(0.0f - 2e+01 / fConst0);
		fConst15 = exp(0.0f - 5e+04 / fConst0);
		fConst16 = 1.0f - fConst1;
	}
	
	void instanceResetUserInterface() nothrow @nogc {
		fHslider0 = cast(FAUSTFLOAT)(5e+01);
		fHslider1 = cast(FAUSTFLOAT)(-1e+02);
		fCheckbox0 = cast(FAUSTFLOAT)(0.0f);
		fHslider2 = cast(FAUSTFLOAT)(-6.0f);
		fHslider3 = cast(FAUSTFLOAT)(0.0f);
		fHslider4 = cast(FAUSTFLOAT)(0.0f);
	}
	
	void instanceClear() nothrow @nogc {
		IOTA0 = 0;
		for (int l0 = 0; l0 < 1024; l0 = l0 + 1) {
			fVec0[l0] = 0.0f;
		}
		for (int l1 = 0; l1 < 2; l1 = l1 + 1) {
			fRec9[l1] = 0.0f;
		}
		for (int l2 = 0; l2 < 2; l2 = l2 + 1) {
			fRec10[l2] = 0.0f;
		}
		for (int l3 = 0; l3 < 1024; l3 = l3 + 1) {
			fVec1[l3] = 0.0f;
		}
		for (int l4 = 0; l4 < 2; l4 = l4 + 1) {
			fRec11[l4] = 0.0f;
		}
		for (int l5 = 0; l5 < 2; l5 = l5 + 1) {
			fRec12[l5] = 0.0f;
		}
		for (int l6 = 0; l6 < 1024; l6 = l6 + 1) {
			fVec2[l6] = 0.0f;
		}
		for (int l7 = 0; l7 < 2; l7 = l7 + 1) {
			fRec13[l7] = 0.0f;
		}
		for (int l8 = 0; l8 < 2; l8 = l8 + 1) {
			fRec14[l8] = 0.0f;
		}
		for (int l9 = 0; l9 < 2048; l9 = l9 + 1) {
			fVec3[l9] = 0.0f;
		}
		for (int l10 = 0; l10 < 2; l10 = l10 + 1) {
			fRec15[l10] = 0.0f;
		}
		for (int l11 = 0; l11 < 2; l11 = l11 + 1) {
			fRec16[l11] = 0.0f;
		}
		for (int l12 = 0; l12 < 128; l12 = l12 + 1) {
			fVec4[l12] = 0.0f;
		}
		for (int l13 = 0; l13 < 2; l13 = l13 + 1) {
			fRec7[l13] = 0.0f;
		}
		for (int l14 = 0; l14 < 64; l14 = l14 + 1) {
			fVec5[l14] = 0.0f;
		}
		for (int l15 = 0; l15 < 2; l15 = l15 + 1) {
			fRec5[l15] = 0.0f;
		}
		for (int l16 = 0; l16 < 12; l16 = l16 + 1) {
			fVec6[l16] = 0.0f;
		}
		for (int l17 = 0; l17 < 2; l17 = l17 + 1) {
			fRec3[l17] = 0.0f;
		}
		for (int l18 = 0; l18 < 3; l18 = l18 + 1) {
			fRec2[l18] = 0.0f;
		}
		for (int l19 = 0; l19 < 3; l19 = l19 + 1) {
			fRec19[l19] = 0.0f;
		}
		for (int l20 = 0; l20 < 2; l20 = l20 + 1) {
			fRec18[l20] = 0.0f;
		}
		for (int l21 = 0; l21 < 2; l21 = l21 + 1) {
			iVec7[l21] = 0;
		}
		for (int l22 = 0; l22 < 2; l22 = l22 + 1) {
			iRec20[l22] = 0;
		}
		for (int l23 = 0; l23 < 2; l23 = l23 + 1) {
			fRec17[l23] = 0.0f;
		}
		for (int l24 = 0; l24 < 2; l24 = l24 + 1) {
			fVec8[l24] = 0.0f;
		}
		for (int l25 = 0; l25 < 2; l25 = l25 + 1) {
			fRec21[l25] = 0.0f;
		}
		for (int l26 = 0; l26 < 2; l26 = l26 + 1) {
			fRec1[l26] = 0.0f;
		}
		for (int l27 = 0; l27 < 2; l27 = l27 + 1) {
			fRec0[l27] = 0.0f;
		}
		for (int l28 = 0; l28 < 2; l28 = l28 + 1) {
			fRec22[l28] = 0.0f;
		}
		for (int l29 = 0; l29 < 2; l29 = l29 + 1) {
			fRec23[l29] = 0.0f;
		}
	}
	
	void initialize(int sample_rate) nothrow @nogc {
		classInit(sample_rate);
		instanceInit(sample_rate);
	}
	void instanceInit(int sample_rate) nothrow @nogc {
		instanceConstants(sample_rate);
		instanceResetUserInterface();
		instanceClear();
	}
	
	DSP_Output clone() {
		return (mallocNew!DSP_Output());
	}
	
	int getSampleRate() nothrow @nogc {
		return fSampleRate;
	}
	
	void buildUserInterface(UI* uiInterface) nothrow @nogc {
		uiInterface.openVerticalBox("OneTrick SIMIAN");
		uiInterface.openTabBox("Globals");
		uiInterface.openVerticalBox("Globals");
		uiInterface.declare(&fHslider4, "0", "");
		uiInterface.addHorizontalSlider("Gain_Global", &fHslider4, cast(FAUSTFLOAT)0.0, cast(FAUSTFLOAT)-1e+02, cast(FAUSTFLOAT)6.0, cast(FAUSTFLOAT)0.1);
		uiInterface.declare(&fHslider2, "1", "");
		uiInterface.addHorizontalSlider("Drive_Global", &fHslider2, cast(FAUSTFLOAT)-6.0, cast(FAUSTFLOAT)-1e+02, cast(FAUSTFLOAT)6.0, cast(FAUSTFLOAT)0.1);
		uiInterface.declare(&fHslider0, "2", "");
		uiInterface.addHorizontalSlider("ReverbDecay_Global", &fHslider0, cast(FAUSTFLOAT)5e+01, cast(FAUSTFLOAT)0.0, cast(FAUSTFLOAT)1e+02, cast(FAUSTFLOAT)0.01);
		uiInterface.declare(&fHslider1, "3", "");
		uiInterface.addHorizontalSlider("ReverbGate_Global", &fHslider1, cast(FAUSTFLOAT)-1e+02, cast(FAUSTFLOAT)-1e+02, cast(FAUSTFLOAT)0.0, cast(FAUSTFLOAT)0.01);
		uiInterface.declare(&fHslider3, "5", "");
		uiInterface.addHorizontalSlider("Saturation_Global", &fHslider3, cast(FAUSTFLOAT)0.0, cast(FAUSTFLOAT)0.0, cast(FAUSTFLOAT)1e+02, cast(FAUSTFLOAT)0.01);
		uiInterface.closeBox();
		uiInterface.closeBox();
		uiInterface.addCheckButton("WakeUp", &fCheckbox0);
		uiInterface.closeBox();
	}
	
	void compute(int count, FAUSTFLOAT*[] inputs, FAUSTFLOAT*[] outputs) nothrow @nogc {
		FAUSTFLOAT* input0 = inputs[0];
		FAUSTFLOAT* input1 = inputs[1];
		FAUSTFLOAT* input2 = inputs[2];
		FAUSTFLOAT* output0 = outputs[0];
		FAUSTFLOAT* output1 = outputs[1];
		float fSlow0 = 0.0075f * cast(float)(fHslider0) + 0.25f;
		int iSlow1 = cast(int)(fmin(1024.0f, fmax(0.0f, fmax(1.0f, 778.0f * fSlow0) + -1.0f)));
		int iSlow2 = cast(int)(fmin(1024.0f, fmax(0.0f, fmax(1.0f, 901.0f * fSlow0) + -1.0f)));
		int iSlow3 = cast(int)(fmin(1024.0f, fmax(0.0f, fmax(1.0f, 1011.0f * fSlow0) + -1.0f)));
		int iSlow4 = cast(int)(fmin(2048.0f, fmax(0.0f, fmax(1.0f, 1123.0f * fSlow0) + -1.0f)));
		float fSlow5 = pow(1e+01, 0.05f * cast(float)(fHslider1));
		float fSlow6 = cast(float)(fCheckbox0);
		float fSlow7 = pow(1e+01, 0.05f * fmax(-1e+02, cast(float)(fHslider2)));
		float fSlow8 = 0.01f * cast(float)(fHslider3);
		float fSlow9 = pow(1e+01, 0.05f * fmax(-1e+02, cast(float)(fHslider4)));
		for (int i0 = 0; i0 < count; i0 = i0 + 1) {
			float fTemp0 = 0.2f * cast(float)(input2[i0]);
			float fTemp1 = 0.827f * fRec9[1] + fTemp0;
			fVec0[IOTA0 & 1023] = fTemp1;
			fRec9[0] = fVec0[(IOTA0 - iSlow1) & 1023];
			fRec10[0] = fTemp1;
			float fTemp2 = fTemp0 + 0.805f * fRec11[1];
			fVec1[IOTA0 & 1023] = fTemp2;
			fRec11[0] = fVec1[(IOTA0 - iSlow2) & 1023];
			fRec12[0] = fTemp2;
			float fTemp3 = fTemp0 + 0.783f * fRec13[1];
			fVec2[IOTA0 & 1023] = fTemp3;
			fRec13[0] = fVec2[(IOTA0 - iSlow3) & 1023];
			fRec14[0] = fTemp3;
			float fTemp4 = fTemp0 + 0.764f * fRec15[1];
			fVec3[IOTA0 & 2047] = fTemp4;
			fRec15[0] = fVec3[(IOTA0 - iSlow4) & 2047];
			fRec16[0] = fTemp4;
			float fTemp5 = fRec16[1] + fRec14[1] + fRec12[1] + 0.7f * fRec7[1] + fRec10[1];
			fVec4[IOTA0 & 127] = fTemp5;
			fRec7[0] = fVec4[(IOTA0 - 124) & 127];
			float fRec8 = 0.0f - 0.7f * fTemp5;
			float fTemp6 = fRec7[1] + fRec8 + 0.7f * fRec5[1];
			fVec5[IOTA0 & 63] = fTemp6;
			fRec5[0] = fVec5[(IOTA0 - 41) & 63];
			float fRec6 = 0.0f - 0.7f * fTemp6;
			float fTemp7 = fRec5[1] + fRec6 + 0.7f * fRec3[1];
			fVec6[0] = fTemp7;
			fRec3[0] = fVec6[11];
			float fRec4 = 0.0f - 0.7f * fTemp7;
			float fTemp8 = fRec4 + fRec3[1];
			fRec2[0] = 0.0f - (fTemp8 + fConst8 * (fConst7 * fRec2[2] + fConst5 * fRec2[1]));
			float fTemp9 = fConst4 * fRec2[0] + fConst9 * fRec2[1] + fConst4 * fRec2[2];
			fRec19[0] = fTemp8 - fConst8 * (fConst7 * fRec19[2] + fConst5 * fRec19[1]);
			float fTemp10 = fConst4 * fRec19[0] + fConst9 * fRec19[1] + fConst4 * fRec19[2];
			fRec18[0] = fConst11 * fabs(fabs(fConst8 * fTemp10) + fabs(fConst8 * fTemp9)) + fConst10 * fRec18[1];
			int iTemp11 = fRec18[0] > fSlow5;
			iVec7[0] = iTemp11;
			iRec20[0] = max(iConst12 * (iTemp11 < iVec7[1]), iRec20[1] + -1);
			float fTemp12 = fabs(fmax(cast(float)(iTemp11), cast(float)(iRec20[0] > 0)));
			float fTemp13 = ((fTemp12 > fRec17[1]) ? fConst10 : fConst13);
			fRec17[0] = fTemp12 * (1.0f - fTemp13) + fRec17[1] * fTemp13;
			fVec8[0] = fSlow6;
			float fTemp14 = cast(float)(fSlow6 <= fVec8[1]);
			float fTemp15 = 1.0f - 0.9995f * fTemp14;
			fRec21[0] = fSlow7 * fTemp15 + 0.9995f * fTemp14 * fRec21[1];
			float fTemp16 = fRec21[0] * (cast(float)(input1[i0]) + fConst8 * fRec17[0] * fTemp9);
			float fTemp17 = fRec21[0] * (cast(float)(input0[i0]) + fConst8 * fRec17[0] * fTemp10);
			float fTemp18 = fabs(fabs(fTemp17) + fabs(fTemp16));
			float fTemp19 = ((fTemp18 > fRec1[1]) ? fConst15 : fConst14);
			fRec1[0] = fTemp18 * (1.0f - fTemp19) + fRec1[1] * fTemp19;
			fRec0[0] = fConst16 * (0.0f - 0.95f * fmax(2e+01 * log10(fmax(1.1754944e-38f, fRec1[0])) + 1.0f, 0.0f)) + fConst1 * fRec0[1];
			float fTemp20 = pow(1e+01, 0.05f * fRec0[0]);
			float fTemp21 = fTemp17 * fTemp20;
			float fTemp22 = fabs(fTemp21);
			fRec22[0] = fSlow8 * fTemp15 + 0.9995f * fTemp14 * fRec22[1];
			float fTemp23 = 1.0f / fmin(fmax(0.4f * fRec22[0] + 0.5f, 0.001f), 0.999f) + -2.0f;
			float fTemp24 = 1.0f - 0.7f * fRec22[0];
			fRec23[0] = fSlow9 * fTemp15 + 0.9995f * fTemp14 * fRec23[1];
			output0[i0] = cast(FAUSTFLOAT)(fRec23[0] * fTemp22 * (1.0f - cast(float)(2 * (fTemp21 < 0.0f))) * fTemp24 / (fTemp23 * (1.0f - fTemp22) + 1.0f));
			float fTemp25 = fTemp16 * fTemp20;
			float fTemp26 = fabs(fTemp25);
			output1[i0] = cast(FAUSTFLOAT)(fRec23[0] * fTemp24 * fTemp26 * (1.0f - cast(float)(2 * (fTemp25 < 0.0f))) / (fTemp23 * (1.0f - fTemp26) + 1.0f));
			IOTA0 = IOTA0 + 1;
			fRec9[1] = fRec9[0];
			fRec10[1] = fRec10[0];
			fRec11[1] = fRec11[0];
			fRec12[1] = fRec12[0];
			fRec13[1] = fRec13[0];
			fRec14[1] = fRec14[0];
			fRec15[1] = fRec15[0];
			fRec16[1] = fRec16[0];
			fRec7[1] = fRec7[0];
			fRec5[1] = fRec5[0];
			for (int j0 = 11; j0 > 0; j0 = j0 - 1) {
				fVec6[j0] = fVec6[j0 - 1];
			}
			fRec3[1] = fRec3[0];
			fRec2[2] = fRec2[1];
			fRec2[1] = fRec2[0];
			fRec19[2] = fRec19[1];
			fRec19[1] = fRec19[0];
			fRec18[1] = fRec18[0];
			iVec7[1] = iVec7[0];
			iRec20[1] = iRec20[0];
			fRec17[1] = fRec17[0];
			fVec8[1] = fVec8[0];
			fRec21[1] = fRec21[0];
			fRec1[1] = fRec1[0];
			fRec0[1] = fRec0[0];
			fRec22[1] = fRec22[0];
			fRec23[1] = fRec23[0];
		}
	}

}

/***************************END USER SECTION ***************************/

/*******************BEGIN ARCHITECTURE SECTION (part 2/2)***************/

/********************END ARCHITECTURE SECTION (part 2/2)****************/
