/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱   
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱  
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━ 

	Copyright (c) 2022 Punk Labs LLC

	This file is part of OneTrick

	OneTrick is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	OneTrick is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

module onetrick.client.core;

import std.math;

import core.stdc.stdio;

import dplug.core.nogc;

import onetrick.client.faust;
import onetrick.string;

struct ParamDescription
{
public:
nothrow:
@nogc:
	string name = "";
	string suffix = "";
	int type = 0; //Float, Bool, Etc
	FaustParam faustParam;
	this(string name, string suffix, FaustParam faustParam, ParamType type = ParamType.Auto)
	{
		if (type == ParamType.Auto)
		{
			if (StringHelper.equals(name, "reserved"))
			{
				type = ParamType.Dummy;
			}
			else
			{
				if (StringHelper.equals(suffix, "dB"))
				{
					type = ParamType.Gain;
				}
				else if (StringHelper.equals(suffix, "Hz") || StringHelper.equals(suffix, "kHz"))
				{
					type = ParamType.LogFloat;
				}
				else
				{
					if (abs(faustParam.step-1.0f) < 0.0001f)
					{
						if(faustParam.min == 0.0f && abs(faustParam.max-1.0f) < 0.0001f)
						{
							type = ParamType.Bool;
						}
						else
						{
							type = ParamType.Integer;
						}
					}
					else
					{
						type = ParamType.Float;
					}
				}
			}
		}
		this.name = StringHelper.duplicateString(name);
		this.suffix = StringHelper.duplicateString(suffix);
		this.type = type;
		this.faustParam = faustParam;
	}
}

enum ParamType
{
	Dummy,
	Bool,
	Enum,
	Float,
	Gain,
	Integer,
	LinearFloat,
	LogFloat,
	PowFloat,
	Auto,
}

