/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱   
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱  
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━ 

	Copyright (c) 2022 Punk Labs LLC

	This file is part of OneTrick

	OneTrick is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	OneTrick is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

module onetrick.ui.creditspanel;

import gui;
import core.atomic;
import dplug.core;
import dplug.gui;
import dplug.canvas;
import dplug.client;

import std.algorithm;
import std.math.trigonometry;

import onetrick.ui.helper;

final class UICreditsPanel : UIElement
{
public:
nothrow:
@nogc:

	@ScriptProperty RGBA colorBackground = RGBA(0, 0, 0, 192);
	@ScriptProperty RGBA colorText = RGBA(255, 255, 255, 255);
	@ScriptProperty float textSize = 25f;

	this(UIContext context, Font font, const(char)[] text)
	{
		super(context, flagRaw);
		this.font = font;
		this.text = text;
	}

	override void onDrawRaw(ImageRef!RGBA rawMap, box2i[] dirtyRects)
	{
		UIHelper.fillColorRaw(rawMap, dirtyRects, colorBackground);
		UIHelper.drawTextRaw(rawMap, dirtyRects, cast(box2f)position, text, font, textSize, colorText);
	}

	override Click onMouseClick(int x, int y, int button, bool isDoubleClick, MouseState mstate)
	{
		//parent().removeChild(this);
		visibility(false);
		return Click.handled;
	}
private:
	Font font;
	const(char)[] text;

}
