/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱   
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱  
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━ 

	Copyright (c) 2022 Punk Labs LLC

	This file is part of OneTrick

	OneTrick is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	OneTrick is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	OneTrick.  If not, see <http://www.gnu.org/licenses/>.
*/

module onetrick.ui.value;

import gui;
import core.atomic;
import dplug.core;
import dplug.gui;
import dplug.canvas;
import dplug.client;
//import dplug.wren;

/// A simple class to expose a value to Wren scripts
final class UIValue : UIElement
{
public:
nothrow:
@nogc:

	@ScriptProperty float floatValue;
	@ScriptProperty int intValue;
	@ScriptProperty bool boolValue;

	this(UIContext context, int value)
	{
		super(context, flagRaw);
		intValue = value;
		floatValue = cast(float)value;
		boolValue = intValue != 0;
	}
	this(UIContext context, float value)
	{
		super(context, flagRaw);
		intValue = cast(int)value;
		floatValue = value;
		boolValue = floatValue != 0;
	}
	this(UIContext context, bool value)
	{
		super(context, flagRaw);
		intValue = value?1:0;
		floatValue = value?1:0;
		boolValue = value;
	}

private:
}
